function [w,msd,k,st]=camera_background_tm09(nframes);
%
%  Model generation: explores the x84 outlier rule during training to
%  estimate the standard deviation at each pixel.
%
%  Input: nframes - number of frames used to train the model
%  Output: 
%           w - the background model using the metrically-trimmed mean
%           msd - mode of estimated standard deviations (not used in  the
%           paper)
%           k - the threshold for foreground detection (set to the default value 3)
%           st - the estimated standard deviation based on the MAD
%
%

%
% Creates a stack with nframes training frames
%
for i = 1:nframes, 
    y = get_image(i);  %reads frame i from video sequence or camera, and returns an image y (must write!)
    if size(y,3)>1,
        y = double(rgb2gray(y));
    end,
    %
    % Stacks all grayscale images in a 3D array x
    %
    x(:,:,i) = y;
end,
%
% Computes the background model
%
[w,msd,k,st] = new_background_metrically_trimmed(x);
%save quadros x
