function back = camera_foreground_tm09(nframes,w,st,k);
%
%  Finds background pixels.
%  Inputs: nframes - number of frames (can be set also as a range of
%                   frames, in the form [initial_frame final_frame]
%          w - the background model
%          st - the noise estimate for each pixel (image same size as w)
%          k - tolerance for foreground detection (scalar)
%
%  Output: back - stack of binary images with the final foreground results
%
countframe = 0;
tempo = 0;
mask_std =[ 0 0 1 0 0; 0 1 1 1 0;1 1 144 1 1;0 1 1 1 0;0 0 1 0 0]/13^2;
std2 = wkeep(conv2(mask_std,(st./(w+.0001)).^2),size(w),'c');
xi = [];
step = 1;
if length(nframes)>1
    nframes = nframes(1):step:nframes(2);
else,
    nframes = 1:nframes;
end,
bw0 = zeros(size(w));
mask = [1 2 1;2 4 2;1 2 1];
%mask = 1;
%mask = ones(3);
smask = sum(mask(:));
if length(st)>1,
    st2 = conv2(st+1.01/smask,mask,'same');
else,
    st2 = smask*st;
end,
for i = nframes,
    y = get_image(i);
    if length(size(y))>2,
        x = rgb2gray(y);
    else,
        x = y;
    end,
    tic,
    countframe = countframe+1;
    z = x;
    %    [i size(x) size(w)]
    bw = conv2(abs(double(x)-double(w)),mask,'same');  %faz o somatorio em torno de cada pixel para um quadro
    d1 = abs(bw)>k*st2;
    %        s = sprintf('fore_all%0.3d.jpg',i);
    %        imwrite(d1,s);

    el1 = strel('diamond',2);
    el2 = strel('diamond',3);
    d1 = imclose(imopen(d1,el1),el2); % initial foreground pixels
    [ba,bs,bh] = detect_shadow_highlight_gaussian(x,w,d1,std2,.7,1);
    %        s = sprintf('fore_shadow%0.3d.jpg',i);
    %        imwrite(d1&not(bs),s);
    d3 = imclose(imopen(d1&not(ba),el1),el2); % foreground pixels after removing shadows and highlights
    %        s = sprintf('fore%0.3d.jpg',i);
    %        imwrite(d3,s);
    back(:,:,countframe)  =  d3;
    x = double(x);
    bw0 = bw;
    tt = toc;
    pf(countframe) = sum(d1(:));
    fps(countframe) = tt;
    tempo = tempo+tt;
end
fps = 1./fps;


